<?php
//------------------------------------------------------------------------------
	
	include_once('bbcode_generic.php');
	
//------------------------------------------------------------------------------
	
	class BBCModernHeaderElement extends BBCGenericElement {
		public function __construct($parent, $name, $args) {
			parent::__construct($parent, $name, $args);
			
			switch ($this->name()) {
				case "h": $this->name("h1"); break;
				default: $this->name("h2"); break;
			}
			
			$this->block(true);
		}
	}
	
	class BBCModernQuoteElement extends BBCGenericElement {
		public function __construct($parent, $name, $args) {
			parent::__construct($parent, $name, $args);
			
			if ($this->name() == "bquote") {
				$this->name("blockquote");
				$this->block(true);
				$this->render(true);
				$this->remainder("cite");
				$this->values = array();
			} else {
				$this->name("q");
			}
		}
	}
	
	class BBCModernCodeElement extends BBCGenericElement {
		public function __construct($parent, $name, $args) {
			parent::__construct($parent, $name, $args);
			
			if ($this->name() == "bcode") {
				$this->name("pre");
				$this->block(true);
			} else {
				$this->name("code");
			}
		}
	}
	
	class BBCModernImageElement extends BBCGenericElement {
		public function __toString() {
			$attributes = "";
			
			$this->remainder("title");
			$this->content("src");
			
			foreach ($this->attributes as $key => $value) {
				$attributes .= ' ' . $key . '="' . $value . '"';
			}
			
			return "<img{$attributes} />";
		}
	}
	
	class BBCModernLinkElement extends BBCGenericElement {
		public function __toString() {
			$this->name("a");
			$this->shift("href");
			$this->remainder("title");
			
			return parent::__toString();
		}
	}
	
//------------------------------------------------------------------------------
	
	function BBCModern($source) {
		$parser = new IBBCParser();
		
		$parser->addElement("h", "BBCModernHeaderElement");
		$parser->addElement("sh", "BBCModernHeaderElement");
		
		$parser->addElement("bcode", "BBCModernCodeElement");
		$parser->addElement("code", "BBCModernCodeElement");
		
		$parser->addElement("bquote", "BBCModernQuoteElement");
		$parser->addElement("quote", "BBCModernQuoteElement");
		$parser->addElement("cite", "BBCGenericElement");
		
		$parser->addElement("a", "BBCModernLinkElement");
		$parser->addElement("img", "BBCModernImageElement");
		
		$parser->addElement("abbr", "BBCGenericElement");
		$parser->addElement("acronym", "BBCGenericElement");
		$parser->addElement("em", "BBCGenericElement");
		$parser->addElement("span", "BBCGenericElement");
		$parser->addElement("strong", "BBCGenericElement");
		
		$document = $parser->parse(trim($source));
		
		return BBCRender($document);
	}
	
//------------------------------------------------------------------------------
?>
