<?php
//------------------------------------------------------------------------------
	
	include_once('bbcode_generic.php');
	
//------------------------------------------------------------------------------
	
	class BBCTraditionalQuoteElement extends BBCGenericElement {
		public function __construct($parent, $name, $args) {
			parent::__construct($parent, $name, $args);
			
			$this->name("blockquote");
			$this->block(true);
			$this->render(true);
		}
		
		public function __toString() {
			$cite = trim(implode($this->args(), ' ')); $output = '';
			
			if ($cite) {
				$output .= "\n<p><cite>{$cite}</cite></p>";
				$this->values = array();
			}
			
			return $output . parent::__toString();
		}
	}
	
	class BBCTraditionalCodeElement extends BBCGenericElement {
		public function __construct($parent, $name, $args) {
			parent::__construct($parent, $name, $args);
			
			$this->name("pre");
			$this->block(true);
		}
	}
	
	class BBCTraditionalImageElement extends BBCGenericElement {
		public function __toString() {
			$attributes = "";
			
			$this->remainder("title");
			$this->content("src");
			
			foreach ($this->attributes as $key => $value) {
				$attributes .= ' ' . $key . '="' . $value . '"';
			}
			
			return "<img{$attributes} />";
		}
	}
	
	class BBCTraditionalLinkElement extends BBCGenericElement {
		public function __toString() {
			$this->name("a");
			$this->shift("href");
			$this->remainder("title");
			
			return parent::__toString();
		}
	}
	
//------------------------------------------------------------------------------
	
	function BBCTraditional($source) {
		$parser = new IBBCParser();
		
		$parser->addElement("code", "BBCTraditionalCodeElement");
		$parser->addElement("img", "BBCTraditionalImageElement");
		$parser->addElement("b", "BBCGenericElement");
		$parser->addElement("em", "BBCGenericElement");
		$parser->addElement("i", "BBCGenericElement");
		$parser->addElement("quote", "BBCTraditionalQuoteElement");
		$parser->addElement("span", "BBCGenericElement");
		$parser->addElement("strong", "BBCGenericElement");
		$parser->addElement("url", "BBCTraditionalLinkElement");
		
		$document = $parser->parse(trim($source));
		
		return BBCRender($document);
	}
	
//------------------------------------------------------------------------------
?>
